#include <string.h>

#include "flac.h"

uint8_t FLAC_Encode_Buffer[MAX_FRAMESIZE];
int32_t FLAC_Decode_Buffer[MAX_BLOCKSIZE];

char FLAC_Init(FIL *f,FLACContext* c)
{
    unsigned char buf[255];
    char found_streaminfo=0;
    int endofmetadata=0;
    int blocklength;
//    uint32_t* p;
//    uint32_t seekpoint_lo,seekpoint_hi;
//   	uint32_t offset_lo,offset_hi;
	int n;

    Fseek(f,0,SEEK_END);
    c->filesize=Ftell(f);

    /*if(*/ Fseek(f,0,SEEK_SET) /*<0)return 0*/ ; // 

    /*if (*/ Fread(buf,1,4,f) /* < 4)
    {
        return 0;
    }*/ ;

    if (memcmp(buf,"fLaC",4) != 0) 
    {
        return 0;
    }
    c->metadatalength = 4;

    while (!endofmetadata) 
	{
        /*if (*/ Fread(buf,1,4,f) /*<4)
        {
            return 0;
        }*/ ;

        endofmetadata=(buf[0]&0x80);
        blocklength = (buf[1] << 16) | (buf[2] << 8) | buf[3];
        c->metadatalength+=blocklength+4;

        if ((buf[0] & 0x7f) == 0)       /* 0 is the STREAMINFO block */
        {
            /* FIXME: Don't trust the value of blocklength */
            /*if (*/ Fread(buf,1,blocklength,f) /*<0)
            {
                return 0;
            }*/ ;
          
            c->min_blocksize = (buf[0] << 8) | buf[1];
            c->max_blocksize = (buf[2] << 8) | buf[3];
            c->min_framesize = (buf[4] << 16) | (buf[5] << 8) | buf[6];
            c->max_framesize = (buf[7] << 16) | (buf[8] << 8) | buf[9];
            c->samplerate = (buf[10] << 12) | (buf[11] << 4) 
                             | ((buf[12] & 0xf0) >> 4);
            c->channels = ((buf[12]&0x0e)>>1) + 1;
            c->bps = (((buf[12]&0x01) << 4) | ((buf[13]&0xf0)>>4) ) + 1;

            /* totalsamples is a 36-bit field, but we assume <= 32 bits are 
               used */
            c->totalsamples = (buf[14] << 24) | (buf[15] << 16) 
                               | (buf[16] << 8) | buf[17];

            /* Calculate track length (in ms) and estimate the bitrate 
               (in kbit/s) */
            c->length = (c->totalsamples / c->samplerate) * 1000;

            found_streaminfo=1;
        }
		else 
		    if ((buf[0] & 0x7f) == 3) 	/* 3 is the SEEKTABLE block */
		    {

                     //printf("Seektable length = %d bytes\n",blocklength);

                while (blocklength >= 18) {
                n=Fread(buf,1,18,f);
                if (n < 18) return 0;
                blocklength-=n;

/*
                p=(uint32_t*)buf;
                seekpoint_hi=betoh32(*(p++));
                seekpoint_lo=betoh32(*(p++));
                offset_hi=betoh32(*(p++));
                offset_lo=betoh32(*(p++));

                if ((seekpoint_hi != 0xffffffff) && (seekpoint_lo != 0xffffffff))
		{
       	         printf("Seekpoint: %u, Offset=%u\n",seekpoint_lo,offset_lo);
                }
*/

            }
            Fseek(f,blocklength,SEEK_CUR);
        } else 
		  {
            /* Skip to next metadata block */
            /*if (*/ Fseek(f,blocklength,SEEK_CUR) /*<0)
            {
                return 0;
            }*/ ;
          }
    }

   if (found_streaminfo)
   {
       c->bitrate = ((c->filesize-c->metadatalength) * 8) / c->length;

       if((c->min_blocksize!=c->max_blocksize)||(c->max_blocksize!= /* > */ MAX_BLOCKSIZE)||(c->max_framesize>MAX_FRAMESIZE))return 0; //  FLAC

       return 1;
   } 
   else return 0;
}

int FLAC_DecodeFrame(FIL *f,FLACContext* c)
{
 static uint32_t bytesleft=0;
 uint32_t n;

 f_read(f,&FLAC_Encode_Buffer[bytesleft],MAX_FRAMESIZE-bytesleft,&n);

 bytesleft+=n;

 flac_decode_frame(c,FLAC_Decode_Buffer,FLAC_Encode_Buffer,bytesleft);

 register int consumed=c->gb.index>>3;

 memmove(FLAC_Encode_Buffer,&FLAC_Encode_Buffer[consumed],bytesleft-consumed);

 bytesleft-=consumed;

 return bytesleft;
}
