#include "sdio_sd.h"

#include "PC_FAT.h"

FATFS FatFsObject;

void FatFs_Init(void)
{
 f_mount(0,&FatFsObject);
}

void FatFs_Deinit(void)
{
 f_mount(0,NULL);
}

int DecodeMode(const char *mode) //!
{
/*
     if((!strcmp(mode,"r" ))||(!strcmp(mode,"rb" )))return FA_READ;
else if((!strcmp(mode,"r+"))||(!strcmp(mode,"r+b")))return FA_READ|FA_WRITE;
else if((!strcmp(mode,"w" ))||(!strcmp(mode,"wb" )))return FA_CREATE_ALWAYS|FA_WRITE;
else if((!strcmp(mode,"w+"))||(!strcmp(mode,"w+b")))return FA_CREATE_ALWAYS|FA_WRITE|FA_READ;
else if((!strcmp(mode,"a" ))||(!strcmp(mode,"ab" )))return FA_OPEN_APPEND|FA_WRITE;
else if((!strcmp(mode,"a+"))||(!strcmp(mode,"a+b")))return FA_OPEN_APPEND|FA_WRITE|FA_READ;
else if( !strcmp(mode,"x" ))                        return FA_CREATE_NEW|FA_WRITE;
else if( !strcmp(mode,"x+"))                        return FA_CREATE_NEW|FA_WRITE;
else                                                return 0xFFFF;
*/
     if((!strcmp(mode,"r" ))||(!strcmp(mode,"rb" )))return FA_READ;

#if !_FS_READONLY

else if((!strcmp(mode,"w" ))||(!strcmp(mode,"wb" )))return FA_CREATE_ALWAYS|FA_WRITE;

#endif

else                                                return 0xFFFF;
}

FIL* Fopen(const char* filename,const char* mode) //NULL   !
{
 FIL* f=malloc(sizeof(FIL));
 if(f_open(f,filename,DecodeMode(mode)))
 {
  free(f);
  return NULL;
 }
 return f;
}

int Fclose(FIL* stream) // 0  , EOF   !
{
 FRESULT r;
 r=f_close(stream);
 free(stream);
 if(r)return EOF;
 return 0;
}

size_t Fread(void* ptr,size_t size,size_t count,FIL* stream) //!
{
 UINT br;
 count*=size;
 f_read(stream,ptr,count,&br);
 if(br!=count)return (size_t)EOF;
 return br/size;
}

#if !_FS_READONLY
size_t Fwrite(const void* ptr,size_t size,size_t count,FIL* stream) //!
{
 UINT bw;
 f_write(stream,ptr,size*count,&bw);
 return bw/size;
}
#endif

long int Ftell(FIL* stream) //!
{
 return f_tell(stream);
}

int Fseek(FIL* stream,long int offset,int origin) // 0  , -1   !
{
 switch(origin)
 {
  case SEEK_SET:return f_lseek(stream,               offset);
  case SEEK_CUR:return f_lseek(stream,f_tell(stream)+offset);
  case SEEK_END:return f_lseek(stream,f_size(stream)+offset);
 }
 return -1;
}

int Fgetc(FIL* stream) //   EOF !
{
 char buf;
 UINT br;
 f_read(stream,&buf,1,&br);
 if(br!=1)return EOF;
 return buf;
}

#if !_FS_READONLY
int Fputc(int character,FIL* stream) //   EOF !
{
 if(f_putc(character,stream)==-1)return EOF;
 return character;
}

int Fputs(const char* str,FIL* stream) //    EOF !
{
 if(f_puts(str,stream)==-1)return EOF;
 return str[strlen(str)-1];
}
#endif

int Feof(FIL* stream) //!
{
 return f_eof(stream);
}
