#ifndef PC_FAT_H
#define PC_FAT_H

#include "Port.h"

#include "diskio.h"
#include "ff.h"

#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

void FatFs_Init(void);
void FatFs_Deinit(void);

FIL* Fopen(const char* filename,const char* mode);
int Fclose(FIL* stream);
size_t Fread(void* ptr,size_t size,size_t count,FIL* stream);

#if !_FS_READONLY

size_t Fwrite(const void* ptr,size_t size,size_t count,FIL* stream);

#endif

long int Ftell(FIL* stream);
int Fseek(FIL* stream,long int offset,int origin);
int Fgetc(FIL* stream);

#if !_FS_READONLY

int Fputc(int character,FIL* stream);
int Fputs(const char* str,FIL* stream);

#endif

int Feof(FIL* stream);

#endif
