/*
        @@@@@    @@@@    @@@@   @@  @@  @@   @@  @@@@   @@  @@
        @@  @@  @@  @@  @@  @@  @@ @@   @@@ @@@ @@  @@  @@@ @@
        @@@@@   @@@@@@  @@      @@@@    @@ @ @@ @@@@@@  @@ @@@
        @@      @@  @@  @@  @@  @@ @@   @@   @@ @@  @@  @@  @@
        @@      @@  @@   @@@@   @@  @@  @@   @@ @@  @@  @@  @@

        @@       @@@@    @@@@    @@@@   @@      @@@@@    @@@@    @@@@
        @@      @@  @@  @@      @@      @@      @@      @@      @@
        @@      @@  @@   @@@@    @@@@   @@      @@@@     @@@@    @@@@
        @@      @@  @@      @@      @@  @@      @@          @@      @@
        @@@@@@   @@@@    @@@@    @@@@   @@@@@@  @@@@@    @@@@    @@@@

        @@  @@  @@@@@@  @@@@@   @@@@@    @@@@
        @@  @@    @@    @@  @@  @@      @@  @@
        @@  @@    @@    @@  @@  @@@@    @@  @@
         @@@@     @@    @@  @@  @@      @@  @@
          @@    @@@@@@  @@@@@   @@@@@    @@@@

         @@@@    @@@@   @@@@@   @@@@@    @@@@
        @@  @@  @@  @@  @@  @@  @@      @@  @@
        @@      @@  @@  @@  @@  @@@@    @@
        @@  @@  @@  @@  @@  @@  @@      @@  @@
         @@@@    @@@@   @@@@@   @@@@@    @@@@

        PackMan Lossless Video DeCoder
        Revision 2 (Multi-Strategy)

        Turbo Version for STM32F407 C
*/

#include "huffman.h"
#include "rle.h"

#define W 160 /*   */
#define H 128 /*   */

#define NW 5  /*  WaveLet  */

u8 nkf;       //No Key Frame

u8 Compress[H*W]; // #2   
s8 WaveLet[W];    //  WaveLet 

s8 Frame[H][W]         __attribute__((aligned (16))); // ,   -  #1   
s8 Frame_Save[3][H][W] __attribute__((aligned (16))); // 

u8 Line[W*3] __attribute__((aligned (16))); //   

FIL *fv;                //   

u32 Len;                //  1/3 
u8 Strategy;            // 

void Line_To_LCD_DMA_Init(void) // DMA    
{
 DMA_InitTypeDef DMA_InitStructure;

 RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2,ENABLE);

 DMA_DeInit(DMA2_Stream0);

 DMA_InitStructure.DMA_Channel = DMA_Channel_0;  
 DMA_InitStructure.DMA_PeripheralBaseAddr=(u32)Line;
 DMA_InitStructure.DMA_Memory0BaseAddr   =(u32)&OLED_Reg_DAT32;
 DMA_InitStructure.DMA_DIR               =DMA_DIR_MemoryToMemory;
 DMA_InitStructure.DMA_BufferSize        =(W*3)>>2;
 DMA_InitStructure.DMA_PeripheralInc     =DMA_PeripheralInc_Enable;
 DMA_InitStructure.DMA_MemoryInc         =DMA_MemoryInc_Disable;
 DMA_InitStructure.DMA_PeripheralDataSize=DMA_PeripheralDataSize_Word;
 DMA_InitStructure.DMA_MemoryDataSize    =DMA_MemoryDataSize_Word;
 DMA_InitStructure.DMA_Mode              =DMA_Mode_Normal;
 DMA_InitStructure.DMA_Priority          =DMA_Priority_Medium;
 DMA_InitStructure.DMA_FIFOMode          =DMA_FIFOMode_Disable;
 DMA_InitStructure.DMA_FIFOThreshold     =DMA_FIFOThreshold_Full;
 DMA_InitStructure.DMA_MemoryBurst       =DMA_MemoryBurst_Single;
 DMA_InitStructure.DMA_PeripheralBurst   =DMA_PeripheralBurst_Single;

 DMA_Init(DMA2_Stream0,&DMA_InitStructure);
}

inline void Line_To_LCD_DMA(void) // DMA  
{
/*
 while(DMA_GetCmdStatus(DMA2_Stream0)!=DISABLE); //while(DMA_GetCurrentMemoryTarget(DMA2_Stream0));
 DMA_ClearITPendingBit(DMA2_Stream0,DMA_IT_TCIF0);
 DMA_Cmd(DMA2_Stream0,ENABLE);
*/

 while(DMA2_Stream0->CR&DMA_SxCR_EN); //More faster than SPL shit :)
 DMA2->LIFCR=DMA_IT_TCIF0&0x0F7D0F7D;
 DMA2_Stream0->CR|=DMA_SxCR_EN;
}

void YCbCr_To_RGB(void) // YCbCr  RGB      (bitexact)
{
 for(register u32 j=0;j<H;j++)
 {
  register u32  *Y=(u32*)&Frame_Save[2][j][0];
  register u32 *CB=(u32*)&Frame_Save[1][j][0];
  register u32 *CR=(u32*)&Frame_Save[0][j][0];
//  register u8  *pl=(u8*)Line;
  register u32 *pL=(u32*)Line;
  register u32 i=W>>2;

  while(i--)
  {

/*
   //,   R,G,B -:

   register u32 G=__UADD8(*CB,*CR);
                G=__USUB8(*Y++,__SHADD8(__SHADD8(__USUB8(G,G&0x03030303),0x00000000),0x00000000)); //floor(n/4) = (n-(n&3))/4
   register u32 R=__UADD8(*CR++,G)<<2;
   register u32 B=__UADD8(*CB++,G)<<2;
   G<<=2;
*/

   // ,   R,G,B -      2:

   register u32 G=__SSUB8(*Y++,__UADD8(*CB,*CR)>>2);
   register u32 R=__UADD8(*CR++,G)<<2;
   register u32 B=__UADD8(*CB++,G)<<2;
   G<<=2;

/*
   RRRRRR** BBBBBB** GGGGGG** RRRRRR** Pixels: 1,2
   GGGGGG** RRRRRR** BBBBBB** GGGGGG** Pixels: 2,3
   BBBBBB** GGGGGG** RRRRRR** BBBBBB** Pixels: 3,4
*/

   //,     - 3:

/*
   OLED_Reg_DAT32=((R<<16)&0xFF000000)|((B<<16)&0x00FF0000)|((G<< 8)&0x0000FF00)|( R     &0x000000FF);
   OLED_Reg_DAT32=((G<< 8)&0xFF000000)|( R     &0x00FF0000)|( B     &0x0000FF00)|((G>> 8)&0x000000FF);
   OLED_Reg_DAT32=( B     &0xFF000000)|((G>> 8)&0x00FF0000)|((R>>16)&0x0000FF00)|((B>>16)&0x000000FF);
*/

   *pL++=((R<<16)&0xFF000000)|((B<<16)&0x00FF0000)|((G<< 8)&0x0000FF00)|( R     &0x000000FF);
   *pL++=((G<< 8)&0xFF000000)|( R     &0x00FF0000)|( B     &0x0000FF00)|((G>> 8)&0x000000FF);
   *pL++=( B     &0xFF000000)|((G>> 8)&0x00FF0000)|((R>>16)&0x0000FF00)|((B>>16)&0x000000FF);

/*
   //  ,      - 12:

   for(register u32 k=0;k<(4*8);k+=8)
   {
    *pl++=R>>k;
    *pl++=G>>k;
    *pl++=B>>k;
   }
*/

  }

  Line_To_LCD_DMA(); //i=(W*3)>>2; while(i--)OLED_Reg_DAT32=*pL++;
 }
}

#if 0
void YCbCr_To_RGB(void) //   SIMD  DMA (bitexact)
{
 for(register u32 j=0;j<H;j++)
 {
  register s8 *Y =&Frame_Save[2][j][0];
  register s8 *CB=&Frame_Save[1][j][0];
  register s8 *CR=&Frame_Save[0][j][0];
  register u32 i=W;

  while(i--)
  {
   register u8 g= *Y++ -((*CB + *CR)>>2); //Reversible Inverse Color Transform: ,  _!!!   int(-x) != floor(-x)
   register u8 r=(*CR++ +g)<<2;
   register u8 b=(*CB++ +g)<<2;

   OLED_Reg_DAT16=((u16)g<<10)|(u16)r;
   OLED_Reg_DAT=b;
  }

 }
}
#endif

inline void LE_GALL_53_I(u32 d) //Le Gall 5/3 Inverse WaveLet Transform(IWT)
{
 register u32 i=(d>>1)-1;
 register u32 j=i;

 //Undo update

 register s8 *wd =&WaveLet[0];
 register s8 *ws0=&WaveLet[1];
 register s8 *ws1=&WaveLet[1];

 *wd-=*ws1/2;

 while(i--)
 {
  wd+=2;
  ws1+=2;
  *wd-=(*ws0+*ws1)/4;
  ws0+=2;
 }

 //Undo predict

 wd =&WaveLet[1];
 ws0=&WaveLet[0];
 ws1=&WaveLet[2];

 while(j--)
 {
  *wd+=(*ws0+*ws1)/2;
  wd+=2;
  ws0+=2;
  ws1+=2;
 }

 *wd+=*ws0;
}

void IWT_X(u32 n)
{
 register u32 w=W>>n;

 for(register u32 y=0;y<H>>n;y++)
 {
  register u32 i=w>>1;

  register s8 *pF0=&Frame[y][0];
  register s8 *pF1=&Frame[y][i];
  register s8 *pW=WaveLet;

  while(i--)
  {
   *pW++=*pF0++;
   *pW++=*pF1++;
  }

  LE_GALL_53_I(w);

  switch(w&3)                         //  ,  memcpy ???
  {
   case 0:                            //4x
   {
    register u32 *PF=(u32*)&Frame[y][0];
    register u32 *PW=(u32*)WaveLet;
    i=w>>2;
    while(i--)*PF++=*PW++;
   }
   break;
   case 2:                            //2x
   {
    register u16 *PF=(u16*)&Frame[y][0];
    register u16 *PW=(u16*)WaveLet;
    i=w>>1;
    while(i--)*PF++=*PW++;
   }
   break;
   default:                           //1x
    pF0=&Frame[y][0];
    pW=WaveLet;
    i=w;
    while(i--)*pF0++=*pW++;
   break;
  }
 }
}

void IWT_Y(u32 n)
{
 register u32 h=H>>n;

 for(register u32 x=0;x<W>>n;x++)
 {
  register u32 i=h>>1;

  register s8* pF0=&Frame[0][x];
  register s8* pF1=&Frame[i][x];
  register s8* pW=WaveLet;

  while(i--)
  {
   *pW++=*pF0;
   *pW++=*pF1;
   pF0+=W;
   pF1+=W;
  }

  LE_GALL_53_I(h);

  pF0=&Frame[0][x];
  pW=WaveLet;

  i=h;
  while(i--)
  {
   *pF0=*pW++;
   pF0+=W;
  }
 }
}

void WaveLetDecode(void)
{
 for(s32 n=NW-1;n>=0;n--) //2D Inverse WaveLet Transform
 {
  IWT_Y(n);
  IWT_X(n);
 }
}

void DifferenceDecode(s32 c)
{
 register u32 *fs=(u32*)&Frame_Save[c];
 register u32 *f =(u32*)&Frame;
 register u32 i=(W*H)>>2;

 if(nkf)while(i--)*fs++=__SADD8(*fs,*f++);
 else   while(i--)*fs++=*f++;
}

void SaveDecode(s32 c)
{
 register u32 *fs=(u32*)&Frame_Save[c];
 register u32 *f =(u32*)&Frame;
 register u32 i=(W*H)>>2;

 while(i--)*fs++=*f++;
}

u8 ReadFrame(FIL *f)        //  
{
 static u8 state=0;         // : 0 -  , 1 -  
 static u32 head_pred;      //    
 u32 head;
 UINT r;

 if(!state)                 //  
 {
  state=1;
  f_read(f,Compress,11,&r); //     1- 
  head=*(u32*)&Compress[8];
 }
 else head=head_pred;       //,     

 head&=0x00FFFFFF;          //3 !

 if(!head)return 0;         //  (  )

 nkf=(head>>23)^1;          //  23    : KeyFrame

 Strategy=(head>>16)&0x0F;  // 16..19:  

 Len=head&0xFFFF;           //  0..15: Compress Frame Size

 //  3  ,      (       ):

 switch(Strategy&3)
 {
  case 0:
  case 2:
   f_read(f,Compress,Len+3,&r);
   head_pred=*(u32*)&Compress[Len];
  break;
  case 1:
  case 3:
   f_read(f,(u8*)Frame,Len+3,&r);
   head_pred=*(u32*)(((u32)&Frame)+Len);
  break;
 }

 return 1;
}

void PackMan_Decode(void)               //  
{
 for(s32 c=2;c>=0;c--)                  //Y Cb Cr  - 
 {
  if(!ReadFrame(fv))NVIC_SystemReset(); //    - 

  switch(Strategy&3) // 2   -  
  {
   case 0:
    DecompressRLE(Compress,Len,(u8*)Frame);
   break;
   case 1:
    DecompressRLE(Compress,DecompressHuffman((u8*)Frame,Len,Compress),(u8*)Frame);
   break;
   case 2:
    DecompressHuffman(Compress,Len,(u8*)Frame);
   break;
   case 3:
    DecompressHuffman(Compress,DecompressRLE((u8*)Frame,Len,Compress),(u8*)Frame);
   break;
  }

  switch(Strategy>>2) // 2   -  
  {
   case 0:
    SaveDecode(c);
   break;
   case 1:
    DifferenceDecode(c);
   break;
   case 2:
    WaveLetDecode();
    DifferenceDecode(c);
   break;
   case 3:
    WaveLetDecode();
    SaveDecode(c);
   break;
  }

 } //loop

 YCbCr_To_RGB(); //YCbCr => RGB +   
}
